; 
; KaKeeware is proud to present a small piece of code that
; demonstrates how to block usermode debuggers from attaching 
; to your process.      
;
; Author: Adam Blaszczyk (c) 2005
; WWW:    http://www.kakeeware.com     
; e-mail: adam[]kakeeware[]com
;
; Feel free to use this source code in your applications, but remember
; that credits are always welcomed :-)                            
;
; ============================================================

.586
.MODEL FLAT,STDCALL

 INCLUDE windows.inc
 CR    = 0Dh
 LF    = 0Ah

 INV equ INVOKE
 OFS  equ OFFSET
 BPTR equ BYTE PTR
 WPTR equ WORD PTR
 DPTR equ DWORD PTR

 MOM  MACRO t:REQ, s:REQ
    push   DPTR s
    pop    t
 ENDM

 INCLUDEX  MACRO plik:REQ
     include    plik.inc
     includelib plik.lib
 ENDM

 INCX MACRO mods:VARARG
   FOR c,<mods>
    INCLUDEX c
   ENDM
 ENDM

 INCX kernel32,user32

.data?
    ddOldProtect dd ?
    ptrDbgUiRemoteBreakin dd ?

.data  
    szNTDLL              db 'ntdll.dll',NULL
    szDbgUiRemoteBreakin db 'DbgUiRemoteBreakin',NULL
    szAntiCaption        db 'AntiAttach',NULL
    szAntiTitleWarning   db 'Gotcha! You are trying to attach debugger...',NULL
    szAntiTitleInfo      db 'Now... try to attach debugger to AntiAttach process.',NULL

.code
  Start:   
    INV GetModuleHandle,OFS szNTDLL
    INV GetProcAddress,eax,OFS szDbgUiRemoteBreakin
    mov ptrDbgUiRemoteBreakin,eax 
        
    INV VirtualProtect,ptrDbgUiRemoteBreakin,1,PAGE_EXECUTE_READWRITE,OFS ddOldProtect
    
    mov eax,ptrDbgUiRemoteBreakin

    mov BPTR [eax+00],068h                        ; PUSH xxxxxxxx
    mov DPTR [eax+01],MB_OK or MB_ICONEXCLAMATION ; PUSH MB_OK or MB_ICONEXCLAMATION

    mov BPTR [eax+05],068h                        ; PUSH xxxxxxxx
    mov DPTR [eax+06],OFS szAntiCaption           ; PUSH OFS szAntiCaption
    
    mov BPTR [eax+10],068h                        ; PUSH xxxxxxxx
    mov DPTR [eax+11],OFS szAntiTitleWarning      ; PUSH OFS szAntiTitle

    mov BPTR [eax+15],068h                        ; PUSH xxxxxxxx
    mov DPTR [eax+16],0                           ; PUSH 0

    mov BPTR [eax+20],0B8h                        ; mov eax,xxxxxxxx
    mov DPTR [eax+21],OFS MessageBoxA             ; mov eax,OFS MessageBoxA
   
    mov WPTR [eax+26],0D0FFh                      ; call eax
    
    mov BPTR [eax+28],0B8h                        ; mov eax,xxxxxxxx
    mov DPTR [eax+29],OFS ExitProcess             ; mov eax,OFS ExitProcess
    
    mov WPTR [eax+33],0D0FFh                      ; call eax
    
    INV MessageBoxA,0,OFS szAntiTitleInfo,OFS szAntiCaption,MB_OK

    ret
END Start
