; Taken from Tutorial "My own tricks to detect OllyDbg" by +Pumqara

.586
.model flat, stdcall
option casemap:none
 

include c:\masm32\INCLUDE\Windows.inc
include c:\masm32\INCLUDE\user32.inc
include c:\masm32\INCLUDE\kernel32.inc
includelib c:\masm32\lib\user32.lib
includelib c:\masm32\lib\kernel32.lib

 

.data
strCaption db "OllyDbg Detector",0
strFound db "OllyDbg found!",0
strNotFound db "OllyDbg NOT found!",0

strLibrary db "kernel32.dll",0
strFunction db "ExitProcess",0

 

.code
start: 

	invoke LoadLibrary,addr strLibrary
	push eax	; eax = kernel32.dll's Image Base
	

	invoke GetProcAddress,eax,addr strFunction
	; eax = ExitProcess's address or redirector ?
	; ebx = kernel32.dll's Image Base
	

	pop ebx		
	cmp eax,ebx 	; Address of ExitProcess < Kernel32.dll's 

			; Image Base ?	
	jl Olly_Detected
	invoke MessageBox,0,addr strNotFound,addr strCaption,NULL
	invoke ExitProcess,0
	

Olly_Detected:
	invoke MessageBox,0,addr strFound,addr strCaption,NULL
	invoke ExitProcess,0
	

end start