;Taken from Tutorial "My own tricks to detect OllyDbg" by +Pumqara

.586
.model flat, stdcall
option casemap:none

include c:\masm32\INCLUDE\Windows.inc
include c:\masm32\INCLUDE\user32.inc
include c:\masm32\INCLUDE\kernel32.inc
includelib c:\masm32\lib\user32.lib
includelib c:\masm32\lib\kernel32.lib

 

.data
strCaption db "OllyDbg Detector!",0
strFound db "OllyDbg found!",0
strNotFound db "OllyDbg NOT found!",0
strOllyDbg db "OLLYDBG.EXE",0h

valCurrentPiD dd 0 
valParentPiD dd 0

hSnapShot dd 0

.data?
proces PROCESSENTRY32 <>

 

.code
start: 

	; Create the snapshot
	invoke CreateToolhelp32Snapshot, TH32CS_SNAPPROCESS,NULL
	mov hSnapShot,eax
	

	;Get the ProcessId of the Current Process
	invoke GetCurrentProcessId
	mov valCurrentPiD,eax
	

	lea esi,offset proces
	assume esi:ptr PROCESSENTRY32
	mov [esi].dwSize,sizeof PROCESSENTRY32
	

	;Begin the first Loop and find the current process

	;using the valCurrentPiD
	invoke Process32First,hSnapShot,addr proces
	

	lea esi,offset proces
	assume esi:ptr PROCESSENTRY32
	mov ebx,valCurrentPiD
	

	cmp ebx,[esi].th32ProcessID
	jne nope1
	

	nope1:
	invoke Process32Next,hSnapShot,addr proces
	

	lea esi,offset proces
	assume esi:ptr PROCESSENTRY32
	

	mov ebx,valCurrentPiD
	cmp ebx,[esi].th32ProcessID
	jne nope1
	

	push [esi].th32ParentProcessID
	pop valParentPiD
	invoke CloseHandle,hSnapShot
	

	; Create the snapshot again
	invoke CreateToolhelp32Snapshot, TH32CS_SNAPPROCESS,NULL
	mov hSnapShot,eax
	

	mov [esi].dwSize,sizeof PROCESSENTRY32
	

	; Begin the second Loop and find the parent

	; process using the valParentPiD
	invoke Process32First,hSnapShot,addr proces
	

	lea esi,offset proces
	assume esi:ptr PROCESSENTRY32
	mov ebx,valParentPiD
	

	cmp ebx,[esi].th32ProcessID
	jne nope2
	

	nope2:
	
	invoke Process32Next,hSnapShot,addr proces
	lea esi,offset proces
	assume esi:ptr PROCESSENTRY32
	mov ebx,valParentPiD
	cmp ebx,[esi].th32ProcessID
	jne nope2
	

	; Extract filename of the Parent Process from the whole string
	lea eax, [esi].szExeFile
	push eax
	invoke lstrlen,eax
	sub eax,11
	pop ebx
	add ebx,eax
	

	; Case Upper the string and compare it with "OLLYDBG.EXE" 
	invoke CharUpper,ebx
	invoke lstrcmp,ebx,addr strOllyDbg
	

	.IF eax==0
		invoke MessageBox,0,addr strFound,addr strCaption,0
	.ELSE
		invoke MessageBox,0,addr strNotFound,addr strCaption,0
	.ENDIF
	

	invoke CloseHandle,hSnapShot
	invoke ExitProcess,0
	

end start